"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const utils = __importStar(require("../utils"));
const lc = __importStar(require("../leetcode"));
const gqlQueries = __importStar(require("../gqlqueries"));
const ListCommand = async (_, state) => {
    const category = state.variables[0].value; // The category filter
    const limit = state.variables[1].value; // The limit filter
    const skip = state.variables[2].value; // The skip filter
    let difficulty = state.variables[3].value.toUpperCase();
    if (difficulty === "ALL")
        difficulty = "";
    const problems_data = await lc.FetchProblems({ category: category, limit: limit, skip: skip, difficulty: difficulty }, utils.FormatProblemsData, gqlQueries.problemListQuery);
    if (!problems_data)
        return state;
    // Shows the problems and some informations
    utils.PrintProblemsSummary(problems_data);
    // Save the list of problems into the state
    state.lastSelectedProblems = problems_data;
    return state;
};
// List command - Lists a number of problems
const list_command = {
    name: 'List Problems Command',
    command: 'list',
    syntax: /^list$/,
    callback: ListCommand,
    help: 'list - Fetches and Lists a number of problems from leetcode.\n' +
        'Filters and all possible variables are those assigned with\n' +
        '`set`, `unset` and shown with `show` commands.\n'
};
exports.default = list_command;
