"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
const UnsetCommand = async (data, state) => {
    // If no values are passed then all variables are resetted
    const condition = data.every((x) => (x === undefined));
    if (condition)
        data = state.variables.map((x) => x.name);
    for (let index = 0; index < data.length; index++) {
        if (data[index] === undefined)
            continue;
        state.variables[index].value = state.variables[index].default;
    }
    return state;
};
// Unset Command - Set variables to their default value
const unset_command = {
    name: 'Unset Command',
    command: 'unset',
    syntax: (0, utils_1.ConstructRegex)('unset', utils_1.app_variables, true),
    callback: UnsetCommand,
    help: 'unset [VAR1 VAR2 ...] - Unset a variable by bringing back to its\n' +
        'default value. Notice that the same rules of `set` holds here.\n' +
        'If no variables are specified, consider resetting all of them.\n'
};
exports.default = unset_command;
